import java.io.File;
import java.io.IOException;

public abstract class Startup {
	
	protected String OS = System.getProperty("os.name").toLowerCase();

	protected void launchMonitor(String mainClass){
		try {

			StringBuilder sb = new StringBuilder();
			sb.append("java").append(" ");
			sb.append("-cp " + getViewerJarPath()).append(" ");
			sb.append("-Xms256m -Xmx384m").append(" "); 
			sb.append("-Djava.library.path=" + getNativeLibraryPath() ).append(" ");
			sb.append(mainClass).append(" ");

			Process p = Runtime.getRuntime().exec(sb.toString());
			
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	protected abstract String getViewerJarPath();
	protected abstract String getNativeLibraryPath();

	public boolean is64BitWindow(){
		boolean is64bit = false;
		if (System.getProperty("os.name").contains("Windows")) {
		    is64bit = (System.getenv("ProgramFiles(x86)") != null);
		} else {
		    is64bit = (System.getProperty("os.arch").indexOf("64") != -1);
		}
		
		return is64bit;
	}

	public boolean isWindows() {
		return (OS.indexOf("win") >= 0);
	}
 
	public boolean isMac() {
		return (OS.indexOf("mac") >= 0);
	}
 
	public boolean isUnix() {
		return (OS.indexOf("nix") >= 0 || OS.indexOf("nux") >= 0 || OS.indexOf("aix") > 0 );
	}
}
